libzypp: zyppng::sat Namespace Reference

libzypp 17.38.14

zyppng::sat Namespace Reference

This file contains private API, this might break at any time between releases. More...

## Namespaces
namespace | detail
| CLASS NAME : detail::DIWrap.
namespace | env
namespace | namespaces

## Classes
class | ArchitectureComponent
| Component managing the Pool architecture. More...
class | ArrayAttr
struct | asSolvable
| To Solvable transform functor. More...
class | AutoInstalledComponent
| Component managing the list of autoinstalled solvables. More...
class | Capabilities
| Container of Capability (currently read only). More...
class | Capability
| A sat capability. More...
class | CapDetail
| Helper providing more detailed information about a Capability. More...
class | CheckSum
class | EvaluatedSolvableSpec
| A SolvableSpec that has been evaluated against a specific Pool. More...
class | IPoolComponent
| Interface for components that run BEFORE the whatprovides index is built. More...
class | IPreparedPoolComponent
| Interface for components that run AFTER the whatprovides index is built. More...
class | LookupAttr
| Lightweight attribute value lookup. More...
class | LookupAttrValue
| Value proxy returned by LookupAttr::iterator::operator*(). More...
class | LookupRepoAttr
| Lightweight repository attribute value lookup. More...
class | MatchException
| Exceptions thrown from attribute matching. More...
class | NamespaceComponent
| Mediator managing the collection of NamespaceProviders for a Pool. More...
class | NamespaceProvider
| Abstract base class for logic providing data to a libsolv namespace. More...
class | PackagePolicyComponent
| Component managing package-level policies: retracted packages, PTF tracking, and the "reboot needed" hint. More...
class | Pool
| Orchestrator for a libsolv pool instance. More...
class | PoolComponentSet
| Registry and dispatcher for all pool components. More...
class | PoolMember
class | PreparedPool
| A move-only, non-owning view of a Pool that guarantees the whatprovides index is valid. More...
class | Queue
| Libsolv Id queue wrapper. More...
class | Repository
class | Solvable
| A Solvable object within the sat Pool. More...
class | SolvableSpec
| A pure data container describing a set of solvables by ident and/or provides. More...
class | SolvAttr
| Solvable attribute keys. More...
class | SplitIdent
| Helper that splits an identifier into kind and name or vice versa. More...
class | StringPool
| Singleton manager for the underlying libsolv string pool. More...
class | StrMatcher
| String matching (STRING|SUBSTRING|GLOB|REGEX). More...

## Typedefs
using | CapabilitySet = std::unordered_set<Capability>
using | SolvableQueue = Queue
| Queue with Solvable ids.
using | StringQueue = Queue
| Queue with String ids.

## Enumerations
enum class | InitStage : size_t { Environment , COUNT }
| Execution stages for IPoolComponent (pre-index phase). More...
enum class | PreparedStage : size_t { Policy , Metadata , Logging , COUNT }
| Execution stages for IPreparedPoolComponent (post-index phase). More...
enum class | PoolInvalidation { Dependency , Data }
| Defines the scope of an invalidation request for the Pool. More...

## Functions
std::ostream & | dumpOn (std::ostream &str, const Queue &obj)
| relates: Queue Stream output assuming a Solvable queue.
bool | operator== (const Capability &lhs, const Capability &rhs)
| relates: Capability
bool | operator!= (const Capability &lhs, const Capability &rhs)
| relates: Capability
bool | operator< (const Capability &lhs, const Capability &rhs)
| relates: Capability Arbitrary order.
bool | operator== (const Queue &lhs, const Queue &rhs)
| relates: Queue
bool | operator!= (const Queue &lhs, const Queue &rhs)
| relates: Queue
bool | operator== (const Repository &lhs, const Repository &rhs)
| relates: Repository
bool | operator!= (const Repository &lhs, const Repository &rhs)
| relates: Repository
bool | operator< (const Repository &lhs, const Repository &rhs)
| relates: Repository
bool | operator== (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable
bool | operator!= (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable
bool | operator< (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable
template<class TRes>
bool | isKind (const Solvable &solvable_r)
| relates: Solvable Test whether a Solvable is of a certain Kind.
bool | identical (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable Test for same content.
bool | sameNVRA (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable Test for same name version release and arch.
int | compareByN (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable Compare according to kind and name.
int | compareByNVR (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable Compare according to kind, name and edition.
int | compareByNVRA (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable Compare according to kind, name, edition and arch.
Helpers and forward declarations from LookupAttrTools.h
template<>
std::string | LookupAttrValue::asType< std::string > () const

## Detailed Description

This file contains private API, this might break at any time between releases.

You have been warned!

## Typedef Documentation

## ◆ CapabilitySet

using zyppng::sat::CapabilitySet = std::unordered_set<Capability>

Definition at line 35 of file capability.h.

## ◆ SolvableQueue

using zyppng::sat::SolvableQueue = Queue

Queue with Solvable ids.

Definition at line 28 of file queue.h.

## ◆ StringQueue

using zyppng::sat::StringQueue = Queue

Queue with String ids.

Definition at line 29 of file queue.h.

## Enumeration Type Documentation

## ◆ InitStage

enum class zyppng::sat::InitStage : size_t
| strong

Execution stages for IPoolComponent (pre-index phase).

Guaranteed to be executed in this order during pool.prepare(), before the whatprovides index is built.

Enumerator
Environment | Arches, Locales, Namespace Callbacks (The Foundation).
COUNT | Sentinel.

Definition at line 35 of file poolcomponents.h.

## ◆ PreparedStage

enum class zyppng::sat::PreparedStage : size_t
| strong

Execution stages for IPreparedPoolComponent (post-index phase).

Guaranteed to be executed in this order during pool.prepare(), after the whatprovides index is built.

Enumerator
Policy | Blacklists, Reboot Specs, Storage Policy.
Metadata | ID-indexed metadata stores.
Logging | Diagnostic components.
COUNT | Sentinel.

Definition at line 45 of file poolcomponents.h.

## ◆ PoolInvalidation

enum class zyppng::sat::PoolInvalidation
| strong

Defines the scope of an invalidation request for the Pool.

This allows providers to notify the pool of changes, avoiding unnecessary cache rebuilding.

Enumerator
Dependency | Only external requirements/context changed (e.g., Locales). The pool content is still valid, but whatprovides must be updated
Data | Structural or data change (e.g., Rootfs, Arch, or Repo content).

Definition at line 66 of file poolconstants.h.

## Function Documentation

## ◆ dumpOn()

std::ostream & zyppng::sat::dumpOn | ( | std::ostream & | str,
|  | const Queue & | obj )

relates: Queue Stream output assuming a Solvable queue.

Definition at line 31 of file queue.cc.

## ◆ operator==() [1/4]

bool zyppng::sat::operator== | ( | const Capability & | lhs,
|  | const Capability & | rhs )
| inline

relates: Capability

Definition at line 311 of file capability.h.

## ◆ operator!=() [1/4]

bool zyppng::sat::operator!= | ( | const Capability & | lhs,
|  | const Capability & | rhs )
| inline

relates: Capability

Definition at line 315 of file capability.h.

## ◆ operator<() [1/3]

bool zyppng::sat::operator< | ( | const Capability & | lhs,
|  | const Capability & | rhs )
| inline

relates: Capability Arbitrary order.

Definition at line 319 of file capability.h.

## ◆ LookupAttrValue::asType< std::string >()

template<>

std::string zyppng::sat::LookupAttrValue::asType< std::string > | ( |  | ) | const
| inline

Definition at line 601 of file lookupattr.h.

## ◆ operator==() [2/4]

bool zyppng::sat::operator== | ( | const Queue & | lhs,
|  | const Queue & | rhs )

relates: Queue

Definition at line 126 of file queue.cc.

## ◆ operator!=() [2/4]

bool zyppng::sat::operator!= | ( | const Queue & | lhs,
|  | const Queue & | rhs )
| inline

relates: Queue

Definition at line 123 of file queue.h.

## ◆ operator==() [3/4]

bool zyppng::sat::operator== | ( | const Repository & | lhs,
|  | const Repository & | rhs )
| inline

relates: Repository

Definition at line 357 of file repository.h.

## ◆ operator!=() [3/4]

bool zyppng::sat::operator!= | ( | const Repository & | lhs,
|  | const Repository & | rhs )
| inline

relates: Repository

Definition at line 361 of file repository.h.

## ◆ operator<() [2/3]

bool zyppng::sat::operator< | ( | const Repository & | lhs,
|  | const Repository & | rhs )
| inline

relates: Repository

Definition at line 365 of file repository.h.

## ◆ operator==() [4/4]

bool zyppng::sat::operator== | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable

Definition at line 350 of file solvable.h.

## ◆ operator!=() [4/4]

bool zyppng::sat::operator!= | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable

Definition at line 354 of file solvable.h.

## ◆ operator<() [3/3]

bool zyppng::sat::operator< | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable

Definition at line 358 of file solvable.h.

## ◆ isKind()

template<class TRes>

bool zyppng::sat::isKind | ( | const Solvable & | solvable_r | ) |
| inline

relates: Solvable Test whether a Solvable is of a certain Kind.

Definition at line 363 of file solvable.h.

## ◆ identical()

bool zyppng::sat::identical | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable Test for same content.

Definition at line 367 of file solvable.h.

## ◆ sameNVRA()

bool zyppng::sat::sameNVRA | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable Test for same name version release and arch.

Definition at line 371 of file solvable.h.

## ◆ compareByN()

int zyppng::sat::compareByN | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable Compare according to kind and name.

Definition at line 376 of file solvable.h.

## ◆ compareByNVR()

int zyppng::sat::compareByNVR | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable Compare according to kind, name and edition.

Definition at line 388 of file solvable.h.

## ◆ compareByNVRA()

int zyppng::sat::compareByNVRA | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable Compare according to kind, name, edition and arch.

Definition at line 397 of file solvable.h.